// OS/2 2.1	Standardrahmen		IBM C-Set/2 Compiler
//
// von Thomas Langenkamp (c) 1993
//
// Name : DIALOG.C


#define INCL_WIN
#define INCL_GPI

#include <os2.h>

// *** Headerdateien ***

#include "dialog.h"
#include "dialog1.h"
#include "dialog2.h"

// *** Fensterprozeduren ***

MRESULT EXPENTRY ClientWndProc (HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2);
MRESULT EXPENTRY Dialog1DlgProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2);
MRESULT EXPENTRY Dialog2DlgProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2);

// *** Globale Variablen ***

BOOL	DlgAktiv = FALSE;	// Flag fr aktives Dialogfenster
			// TRUE  - Fenster erffnet
			// FALSE - Fenster geschlossen


INT main (VOID)
{
	HAB	hab;

	HMQ   	hmq;
	QMSG  	qmsg;

	HWND  	hwndClientFrame,
		hwndClient;

	ULONG 	FrameCreationFlags = FCF_TITLEBAR |
			     FCF_SYSMENU |
			     FCF_SIZEBORDER |
			     FCF_MINMAX |
			     FCF_SHELLPOSITION |
			     FCF_TASKLIST |
			     FCF_ICON |
			     FCF_MENU;

hab = WinInitialize (0);
hmq = WinCreateMsgQueue (hab,0);

WinDlgBox (HWND_DESKTOP,
           HWND_DESKTOP,
           Dialog1DlgProc,
           (HMODULE) 0,
           ID_DialogBox1,
           NULL);

WinRegisterClass (hab,
	  "Hauptfenster",
	  ClientWndProc,
	  CS_SIZEREDRAW,
	  0);

hwndClientFrame = WinCreateStdWindow (HWND_DESKTOP,
		      WS_VISIBLE,
		      &FrameCreationFlags,
		      "Hauptfenster",
		      "Dialogkstchen",
		      WS_VISIBLE,
		      (HMODULE)0,
		      ID_ClientWindow,
		      &hwndClient);

while (WinGetMsg (hab,&qmsg,0L,0,0))
      WinDispatchMsg (hab,&qmsg);

WinDestroyWindow (hwndClientFrame);

WinDestroyMsgQueue (hmq);

WinTerminate (hab);

return 0;
}


// *** Fensterprozeduren ***

MRESULT EXPENTRY ClientWndProc (HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
	HPS	hps;

switch (msg)
      {
       case WM_CREATE:
            break;

       case WM_SIZE:
            break;

       case WM_PAINT:
            hps = WinBeginPaint (hwnd,NULLHANDLE,NULL);
             GpiErase (hps);
            WinEndPaint (hps);
            break;

       case WM_COMMAND:
            switch (SHORT1FROMMP (mp1))
	  {
	   case IDM_Beispiel1:
	        if (DlgAktiv == FALSE)		// Dailogfenster einblenden,
	           WinLoadDlg (HWND_DESKTOP,	// wenn DlGAktiv = FALSE
		       hwnd,		// Fenster also nicht aktiv ist
		       Dialog1DlgProc,
		       (HMODULE) 0,
		       ID_DialogBox1,
		       NULL);
	        else
	           WinMessageBox (HWND_DESKTOP,	// Nachricht, da Fenster aktiv
		          hwnd,
		          "Dialogfenster bereits aktiv",
		          "Information",
		          0,
		          MB_OK | MB_MOVEABLE | MB_ERROR);
	        break;

	   case IDM_Beispiel2:
	        WinDlgBox (HWND_DESKTOP,	// Dialogkstchen laden und auf
		   hwnd,		// dessen Beendigung warten
		   Dialog2DlgProc,
		   (HMODULE) 0,
		   ID_DialogBox2,
		   NULL);
	        break;
	  }
            break;

       case WM_CLOSE:
            WinPostMsg (hwnd,WM_QUIT,(MPARAM)0,(MPARAM)0);
            break;

       default:
            return WinDefWindowProc (hwnd,msg,mp1,mp2);
      }

return (MRESULT)FALSE;
}


MRESULT EXPENTRY Dialog1DlgProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{

switch (msg)
      {
       case WM_INITDLG:
            DlgAktiv = TRUE;			// Fensterstatus auf aktiv setzen
            break;

       case WM_COMMAND:
            switch (SHORT1FROMMP (mp1))
	  {
	   case DID_OK:
	        DlgAktiv = FALSE;		// Fensterstatus auf
	        WinDismissDlg (hwnd,DID_OK);	// nicht aktiv setzen
	        break;			// und Dialogbox schlieen
	  }
            break;

       case WM_CLOSE:
            DlgAktiv = FALSE;			// Fenster auf nicht
            break;			// aktiv setzen

       default:
            return WinDefDlgProc (hwnd,msg,mp1,mp2);
            break;
      }

return (MRESULT)FALSE;
}


MRESULT EXPENTRY Dialog2DlgProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{

	INT	z;

static	INT	Anzahl = 20;

	// Tabelle fr Auswahlkstchen
static	CHAR	*szTabelle [] =
		     {"Eintrag 1","Eintrag 2","Eintrag 3",
		      "Eintrag 4","Eintrag 5","Eintrag 6",
		      "Eintrag 7","Eintrag 8","Eintrag 9",
		      "Eintrag 10","Eintrag 11","Eintrag 12",
		      "Eintrag 13","Eintrag 14","Eintrag 15",
		      "Eintrag 16","Eintrag 17","Eintrag 18",
		      "Eintrag 19","Eintrag 20"};

switch (msg)
      {
       case WM_INITDLG:
            for (z=0; z < Anzahl; z++)		// Auswahlkstchen mit Eintrgen
               {			// fllen
	WinSendDlgItemMsg (hwnd,
		   ID_Listbox,
		   LM_INSERTITEM,
		   MPFROMSHORT (LIT_END),
		   szTabelle [z]);
               }

            WinSendDlgItemMsg (hwnd,		// Schalter A stnadardmig
	               ID_Schalter_A,		// markieren
	               BM_SETCHECK,
	               (MPARAM) 1,
	               NULL);
            break;

       case WM_COMMAND:
            switch (SHORT1FROMMP (mp1))
	  {
	   case DID_OK:
	        if (WinSendDlgItemMsg (hwnd,	// wenn Schalter A markiert,
		               ID_Schalter_A,	// Nachrichtenkstchen
		               BM_QUERYCHECK,	// einblenden
		               NULL,
		               NULL))
	           WinMessageBox (HWND_DESKTOP,
		          hwnd,
		          "Schalter A ist aktiv",
		          "Information",
		          0,
		          MB_OK | MB_MOVEABLE | MB_INFORMATION);

	        if (WinSendDlgItemMsg (hwnd,	// wenn Schalter B markiert,
		               ID_Schalter_B,	// Nachrichtenkstchen
		               BM_QUERYCHECK,	// einblenden
		               NULL,
		               NULL))
	           WinMessageBox (HWND_DESKTOP,
		          hwnd,
		          "Schalter B ist aktiv",
		          "Information",
		          0,
		          MB_OK | MB_MOVEABLE | MB_INFORMATION);

	        WinDismissDlg (hwnd,DID_OK);	// Dialogkstchen schlieen
	        break;

	   case DID_CANCEL:
	        WinDismissDlg (hwnd,DID_CANCEL);	// Dialogkstchen schlieen
	        break;
	  }
            break;

       default:
            return WinDefDlgProc (hwnd,msg,mp1,mp2);
      }

return (MRESULT)FALSE;
}
